"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const fs = require("fs");
const path = require("path");
const logger_1 = require("../utils/logger");
const payloadFileLocation = path.join(__dirname, "..", "payload", "payload.txt");
const charArray = ["R", "U", "D", "Y"];
class GeneratePayload {
    constructor(charCount) {
        this.charCount = charCount;
    }
    run() {
        fs.unlink(payloadFileLocation, (err) => {
            logger_1.default.verbose({ message: "payload.txt deleted", category: "GENERATE_PAYLOAD" });
            this.generatePayload();
        });
    }
    generatePayload() {
        this.stream = fs.createWriteStream(payloadFileLocation);
        for (var i = 0; i < this.charCount; i++) {
            this.stream.write(this.getRandomString());
        }
        logger_1.default.info({ message: "Payload Injected with characters : " + this.charCount,
            category: "GENERATE_PAYLOAD" });
        this.stream.end();
    }
    getRandomString() {
        const low = 0;
        const high = 4;
        const randomNumber = Math.floor(Math.random() * (high - low) + low);
        return charArray[randomNumber];
    }
}
exports.default = GeneratePayload;
