"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const request = require("request");
const tr = require("tor-request");
var HTTPMethod;
(function (HTTPMethod) {
    HTTPMethod["GET"] = "GET";
    HTTPMethod["POST"] = "POST";
    HTTPMethod["PUT"] = "PUT";
})(HTTPMethod = exports.HTTPMethod || (exports.HTTPMethod = {}));
class NetworkService {
    constructor() {
        this.serviceName = "Network_Service";
    }
    static setTorAddress(config) {
        tr.setTorAddress((config.url != null ? config.url : "127.0.0.1"), (config.port != null ? config.port : 9050));
    }
    static request(payload) {
        if (payload.shouldUseTor) {
            return NetworkService.torRequest(payload);
        }
        return new Promise((resolve, reject) => {
            request({
                method: payload.method,
                uri: payload.url,
                headers: payload.headers,
                formData: {
                    file: payload.data,
                },
            }, (error, response, body) => {
                if (error) {
                    return reject({ code: 404, err: error });
                }
                return resolve({ status: response.statusCode, message: body });
            });
        });
    }
    static torRequest(payload) {
        return new Promise((resolve, reject) => {
            tr.request({
                method: payload.method,
                uri: payload.url,
                headers: payload.headers,
                formData: {
                    file: payload.data,
                },
            }, (error, response, body) => {
                if (error) {
                    return reject({ code: 404, err: error });
                }
                return resolve({ status: response.statusCode, message: body });
            });
        });
    }
}
exports.default = NetworkService;
