"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = require("chalk");
const error = chalk_1.default.red;
const verbose = chalk_1.default.yellow;
const info = chalk_1.default.blue;
var LogLevel;
(function (LogLevel) {
    LogLevel["INFO"] = "INFO";
    LogLevel["VERBOSE"] = "VERBOSE";
    LogLevel["ERROR"] = "ERROR";
})(LogLevel = exports.LogLevel || (exports.LogLevel = {}));
class Logger {
    setLogLevel(level) {
        Logger.logLevel = level;
        this.verbose({ message: "Logger set to Verbose", category: "Logger" });
    }
    error(params) {
        this.logMessage(error(this.getLogMessage(params, LogLevel.ERROR)), params);
    }
    verbose(params) {
        if (Logger.logLevel === LogLevel.VERBOSE) {
            this.logMessage(verbose(this.getLogMessage(params, LogLevel.VERBOSE)), params);
        }
    }
    info(params) {
        this.logMessage(info(this.getLogMessage(params, LogLevel.INFO)), params);
    }
    logMessage(text, params) {
        console.log(text);
        if (params.data != null) {
            console.log(params.data);
        }
    }
    getLogMessage(params, logType) {
        return new Date() + " *** " + logType + " ::: "
            + params.category + " ::: " + params.message + " ***";
    }
}
Logger.logLevel = LogLevel.INFO;
const logger = new Logger();
exports.default = logger;
